{
  This file was automatically generated on 2017-05-11.

  Delphi/Lazarus Bindings Version 2.1.15

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletLEDStrip;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_LED_STRIP_DEVICE_IDENTIFIER = 231;
  BRICKLET_LED_STRIP_DEVICE_DISPLAY_NAME = 'LED Strip Bricklet';

  BRICKLET_LED_STRIP_FUNCTION_SET_RGB_VALUES = 1;
  BRICKLET_LED_STRIP_FUNCTION_GET_RGB_VALUES = 2;
  BRICKLET_LED_STRIP_FUNCTION_SET_FRAME_DURATION = 3;
  BRICKLET_LED_STRIP_FUNCTION_GET_FRAME_DURATION = 4;
  BRICKLET_LED_STRIP_FUNCTION_GET_SUPPLY_VOLTAGE = 5;
  BRICKLET_LED_STRIP_FUNCTION_SET_CLOCK_FREQUENCY = 7;
  BRICKLET_LED_STRIP_FUNCTION_GET_CLOCK_FREQUENCY = 8;
  BRICKLET_LED_STRIP_FUNCTION_SET_CHIP_TYPE = 9;
  BRICKLET_LED_STRIP_FUNCTION_GET_CHIP_TYPE = 10;
  BRICKLET_LED_STRIP_FUNCTION_SET_RGBW_VALUES = 11;
  BRICKLET_LED_STRIP_FUNCTION_GET_RGBW_VALUES = 12;
  BRICKLET_LED_STRIP_FUNCTION_SET_CHANNEL_MAPPING = 13;
  BRICKLET_LED_STRIP_FUNCTION_GET_CHANNEL_MAPPING = 14;
  BRICKLET_LED_STRIP_FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK = 15;
  BRICKLET_LED_STRIP_FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK = 16;
  BRICKLET_LED_STRIP_FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED = 17;
  BRICKLET_LED_STRIP_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_LED_STRIP_CALLBACK_FRAME_RENDERED = 6;

  BRICKLET_LED_STRIP_CHIP_TYPE_WS2801 = 2801;
  BRICKLET_LED_STRIP_CHIP_TYPE_WS2811 = 2811;
  BRICKLET_LED_STRIP_CHIP_TYPE_WS2812 = 2812;
  BRICKLET_LED_STRIP_CHIP_TYPE_LPD8806 = 8806;
  BRICKLET_LED_STRIP_CHIP_TYPE_APA102 = 102;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RGB = 6;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RBG = 9;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BRG = 33;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BGR = 36;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GRB = 18;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GBR = 24;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RGBW = 27;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RGWB = 30;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RBGW = 39;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RBWG = 45;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RWGB = 54;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_RWBG = 57;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GRWB = 78;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GRBW = 75;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GBWR = 108;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GBRW = 99;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GWBR = 120;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_GWRB = 114;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BRGW = 135;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BRWG = 141;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BGRW = 147;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BGWR = 156;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BWRG = 177;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_BWGR = 180;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WRBG = 201;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WRGB = 198;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WGBR = 216;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WGRB = 210;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WBGR = 228;
  BRICKLET_LED_STRIP_CHANNEL_MAPPING_WBRG = 225;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To11OfUInt8 = array [0..11] of byte;
  TArray0To15OfUInt8 = array [0..15] of byte;

  TBrickletLEDStrip = class;
  TBrickletLEDStripNotifyFrameRendered = procedure(sender: TBrickletLEDStrip; const length2: word) of object;

  /// <summary>
  ///  Controls up to 320 RGB LEDs
  /// </summary>
  TBrickletLEDStrip = class(TDevice)
  private
    frameRenderedCallback: TBrickletLEDStripNotifyFrameRendered;
  protected
    procedure CallbackWrapperFrameRendered(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Sets the RGB values for the LEDs with the given *length* starting
    ///  from *index*.
    ///  
    ///  To make the colors show correctly you need to configure the chip type
    ///  (<see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChipType"/>) and a 3-channel channel mapping (<see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChannelMapping"/>)
    ///  according to the connected LEDs.
    ///  
    ///  The maximum length is 16, the index goes from 0 to 319 and the rgb values
    ///  have 8 bits each.
    ///  
    ///  Example: If you set
    ///  
    ///  * index to 5,
    ///  * length to 3,
    ///  * r to [255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    ///  * g to [0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] and
    ///  * b to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    ///  
    ///  the LED with index 5 will be red, 6 will be green and 7 will be blue.
    ///  
    ///  .. note:: Depending on the LED circuitry colors can be permuted.
    ///  
    ///  The colors will be transfered to actual LEDs when the next
    ///  frame duration ends, see <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetFrameDuration"/>.
    ///  
    ///  Generic approach:
    ///  
    ///  * Set the frame duration to a value that represents
    ///    the number of frames per second you want to achieve.
    ///  * Set all of the LED colors for one frame.
    ///  * Wait for the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  * Set all of the LED colors for next frame.
    ///  * Wait for the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  * and so on.
    ///  
    ///  This approach ensures that you can change the LED colors with
    ///  a fixed frame rate.
    ///  
    ///  The actual number of controllable LEDs depends on the number of free
    ///  Bricklet ports. See :ref:`here &lt;led_strip_bricklet_ram_constraints&gt;` for more
    ///  information. A call of <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/> with index + length above the
    ///  bounds is ignored completely.
    /// </summary>
    procedure SetRGBValues(const index: word; const length2: byte; const r: TArray0To15OfUInt8; const g: TArray0To15OfUInt8; const b: TArray0To15OfUInt8); virtual;

    /// <summary>
    ///  Returns RGB value with the given *length* starting from the
    ///  given *index*.
    ///  
    ///  The values are the last values that were set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/>.
    /// </summary>
    procedure GetRGBValues(const index: word; const length2: byte; out r: TArray0To15OfUInt8; out g: TArray0To15OfUInt8; out b: TArray0To15OfUInt8); virtual;

    /// <summary>
    ///  Sets the frame duration in ms.
    ///  
    ///  Example: If you want to achieve 20 frames per second, you should
    ///  set the frame duration to 50ms (50ms * 20 = 1 second).
    ///  
    ///  For an explanation of the general approach see <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/>.
    ///  
    ///  Default value: 100ms (10 frames per second).
    /// </summary>
    procedure SetFrameDuration(const duration: word); virtual;

    /// <summary>
    ///  Returns the frame duration in ms as set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetFrameDuration"/>.
    /// </summary>
    function GetFrameDuration: word; virtual;

    /// <summary>
    ///  Returns the current supply voltage of the LEDs. The voltage is given in mV.
    /// </summary>
    function GetSupplyVoltage: word; virtual;

    /// <summary>
    ///  Sets the frequency of the clock in Hz. The range is 10000Hz (10kHz) up to
    ///  2000000Hz (2MHz).
    ///  
    ///  The Bricklet will choose the nearest achievable frequency, which may
    ///  be off by a few Hz. You can get the exact frequency that is used by
    ///  calling <see cref="BrickletLEDStrip.TBrickletLEDStrip.GetClockFrequency"/>.
    ///  
    ///  If you have problems with flickering LEDs, they may be bits flipping. You
    ///  can fix this by either making the connection between the LEDs and the
    ///  Bricklet shorter or by reducing the frequency.
    ///  
    ///  With a decreasing frequency your maximum frames per second will decrease
    ///  too.
    ///  
    ///  The default value is 1.66MHz.
    ///  
    ///  <note>
    ///   The frequency in firmware version 2.0.0 is fixed at 2MHz.
    ///  </note>
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure SetClockFrequency(const frequency: longword); virtual;

    /// <summary>
    ///  Returns the currently used clock frequency as set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetClockFrequency"/>.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    function GetClockFrequency: longword; virtual;

    /// <summary>
    ///  Sets the type of the LED driver chip. We currently support the chips
    ///  
    ///  * WS2801,
    ///  * WS2811,
    ///  * WS2812 / SK6812 / NeoPixel RGB,
    ///  * SK6812RGBW / NeoPixel RGBW (Chip Type = WS2812),
    ///  * LPD8806 and
    ///  * APA102 / DotStar.
    ///  
    ///  The default value is WS2801 (2801).
    ///  
    ///  .. versionadded:: 2.0.2$nbsp;(Plugin)
    /// </summary>
    procedure SetChipType(const chip: word); virtual;

    /// <summary>
    ///  Returns the currently used chip type as set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChipType"/>.
    ///  
    ///  .. versionadded:: 2.0.2$nbsp;(Plugin)
    /// </summary>
    function GetChipType: word; virtual;

    /// <summary>
    ///  Sets the RGBW values for the LEDs with the given *length* starting
    ///  from *index*.
    ///  
    ///  To make the colors show correctly you need to configure the chip type
    ///  (<see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChipType"/>) and a 4-channel channel mapping (<see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChannelMapping"/>)
    ///  according to the connected LEDs.
    ///  
    ///  The maximum length is 12, the index goes from 0 to 239 and the rgbw values
    ///  have 8 bits each.
    ///  
    ///  Example: If you set
    ///  
    ///  * index to 5,
    ///  * length to 4,
    ///  * r to [255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    ///  * g to [0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    ///  * b to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0] and
    ///  * w to [0, 0, 255, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    ///  
    ///  the LED with index 5 will be red, 6 will be green, 7 will be blue and 8 will be white.
    ///  
    ///  .. note:: Depending on the LED circuitry colors can be permuted.
    ///  
    ///  The colors will be transfered to actual LEDs when the next
    ///  frame duration ends, see <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetFrameDuration"/>.
    ///  
    ///  Generic approach:
    ///  
    ///  * Set the frame duration to a value that represents
    ///    the number of frames per second you want to achieve.
    ///  * Set all of the LED colors for one frame.
    ///  * Wait for the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  * Set all of the LED colors for next frame.
    ///  * Wait for the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  * and so on.
    ///  
    ///  This approach ensures that you can change the LED colors with
    ///  a fixed frame rate.
    ///  
    ///  The actual number of controllable LEDs depends on the number of free
    ///  Bricklet ports. See :ref:`here &lt;led_strip_bricklet_ram_constraints&gt;` for more
    ///  information. A call of <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBWValues"/> with index + length above the
    ///  bounds is ignored completely.
    ///  
    ///  The LPD8806 LED driver chips have 7-bit channels for RGB. Internally the LED
    ///  Strip Bricklets divides the 8-bit values set using this function by 2 to make
    ///  them 7-bit. Therefore, you can just use the normal value range (0-255) for
    ///  LPD8806 LEDs.
    ///  
    ///  The brightness channel of the APA102 LED driver chips has 5-bit. Internally the
    ///  LED Strip Bricklets divides the 8-bit values set using this function by 8 to make
    ///  them 5-bit. Therefore, you can just use the normal value range (0-255) for
    ///  the brightness channel of APA102 LEDs.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    procedure SetRGBWValues(const index: word; const length2: byte; const r: TArray0To11OfUInt8; const g: TArray0To11OfUInt8; const b: TArray0To11OfUInt8; const w: TArray0To11OfUInt8); virtual;

    /// <summary>
    ///  Returns RGBW values with the given *length* starting from the
    ///  given *index*.
    ///  
    ///  The values are the last values that were set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBWValues"/>.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    procedure GetRGBWValues(const index: word; const length2: byte; out r: TArray0To11OfUInt8; out g: TArray0To11OfUInt8; out b: TArray0To11OfUInt8; out w: TArray0To11OfUInt8); virtual;

    /// <summary>
    ///  Sets the channel mapping for the connected LEDs.
    ///  
    ///  <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/> and <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBWValues"/> take the data in RGB(W) order.
    ///  But the connected LED driver chips might have their 3 or 4 channels in a
    ///  different order. For example, the WS2801 chips typically use BGR order, the
    ///  WS2812 chips typically use GRB order and the APA102 chips typically use WBGR
    ///  order.
    ///  
    ///  The APA102 chips are special. They have three 8-bit channels for RGB
    ///  and an additional 5-bit channel for the overall brightness of the RGB LED
    ///  making them 4-channel chips. Internally the brightness channel is the first
    ///  channel, therefore one of the Wxyz channel mappings should be used. Then
    ///  the W channel controls the brightness.
    ///  
    ///  If a 3-channel mapping is selected then <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/> has to be used.
    ///  Calling <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBWValues"/> with a 3-channel mapping will produce incorrect
    ///  results. Vice-versa if a 4-channel mapping is selected then
    ///  <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBWValues"/> has to be used. Calling <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/> with a
    ///  4-channel mapping will produce incorrect results.
    ///  
    ///  The default value is BGR (36).
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    procedure SetChannelMapping(const mapping: byte); virtual;

    /// <summary>
    ///  Returns the currently used channel mapping as set by <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetChannelMapping"/>.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    function GetChannelMapping: byte; virtual;

    /// <summary>
    ///  Enables the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  
    ///  By default the callback is enabled.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    procedure EnableFrameRenderedCallback; virtual;

    /// <summary>
    ///  Disables the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback.
    ///  
    ///  By default the callback is enabled.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    procedure DisableFrameRenderedCallback; virtual;

    /// <summary>
    ///  Returns *true* if the <see cref="BrickletLEDStrip.TBrickletLEDStrip.OnFrameRendered"/> callback is enabled, *false* otherwise.
    ///  
    ///  .. versionadded:: 2.0.6$nbsp;(Plugin)
    /// </summary>
    function IsFrameRenderedCallbackEnabled: boolean; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered directly after a new frame is rendered. The
    ///  parameter is the number of LEDs in that frame.
    ///  
    ///  You should send the data for the next frame directly after this callback
    ///  was triggered.
    ///  
    ///  For an explanation of the general approach see <see cref="BrickletLEDStrip.TBrickletLEDStrip.SetRGBValues"/>.
    /// </summary>
    property OnFrameRendered: TBrickletLEDStripNotifyFrameRendered read frameRenderedCallback write frameRenderedCallback;
  end;

implementation

constructor TBrickletLEDStrip.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 3;

  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_RGB_VALUES] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_RGB_VALUES] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_FRAME_DURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_SUPPLY_VOLTAGE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_CALLBACK_FRAME_RENDERED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_CLOCK_FREQUENCY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_CLOCK_FREQUENCY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_CHIP_TYPE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_CHIP_TYPE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_RGBW_VALUES] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_RGBW_VALUES] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_SET_CHANNEL_MAPPING] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_CHANNEL_MAPPING] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LED_STRIP_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_LED_STRIP_CALLBACK_FRAME_RENDERED] := {$ifdef FPC}@{$endif}CallbackWrapperFrameRendered;
end;

procedure TBrickletLEDStrip.SetRGBValues(const index: word; const length2: byte; const r: TArray0To15OfUInt8; const g: TArray0To15OfUInt8; const b: TArray0To15OfUInt8);
var request: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_RGB_VALUES, 59);
  LEConvertUInt16To(index, 8, request);
  LEConvertUInt8To(length2, 10, request);
  for i := 0 to Length(r) - 1 do LEConvertUInt8To(r[i], 11 + (i * 1), request);
  for i := 0 to Length(g) - 1 do LEConvertUInt8To(g[i], 27 + (i * 1), request);
  for i := 0 to Length(b) - 1 do LEConvertUInt8To(b[i], 43 + (i * 1), request);
  SendRequest(request);
end;

procedure TBrickletLEDStrip.GetRGBValues(const index: word; const length2: byte; out r: TArray0To15OfUInt8; out g: TArray0To15OfUInt8; out b: TArray0To15OfUInt8);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_RGB_VALUES, 11);
  LEConvertUInt16To(index, 8, request);
  LEConvertUInt8To(length2, 10, request);
  response := SendRequest(request);
  for i := 0 to 15 do r[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 15 do g[i] := LEConvertUInt8From(24 + (i * 1), response);
  for i := 0 to 15 do b[i] := LEConvertUInt8From(40 + (i * 1), response);
end;

procedure TBrickletLEDStrip.SetFrameDuration(const duration: word);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_FRAME_DURATION, 10);
  LEConvertUInt16To(duration, 8, request);
  SendRequest(request);
end;

function TBrickletLEDStrip.GetFrameDuration: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_FRAME_DURATION, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

function TBrickletLEDStrip.GetSupplyVoltage: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_SUPPLY_VOLTAGE, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletLEDStrip.SetClockFrequency(const frequency: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_CLOCK_FREQUENCY, 12);
  LEConvertUInt32To(frequency, 8, request);
  SendRequest(request);
end;

function TBrickletLEDStrip.GetClockFrequency: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_CLOCK_FREQUENCY, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletLEDStrip.SetChipType(const chip: word);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_CHIP_TYPE, 10);
  LEConvertUInt16To(chip, 8, request);
  SendRequest(request);
end;

function TBrickletLEDStrip.GetChipType: word;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_CHIP_TYPE, 8);
  response := SendRequest(request);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletLEDStrip.SetRGBWValues(const index: word; const length2: byte; const r: TArray0To11OfUInt8; const g: TArray0To11OfUInt8; const b: TArray0To11OfUInt8; const w: TArray0To11OfUInt8);
var request: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_RGBW_VALUES, 59);
  LEConvertUInt16To(index, 8, request);
  LEConvertUInt8To(length2, 10, request);
  for i := 0 to Length(r) - 1 do LEConvertUInt8To(r[i], 11 + (i * 1), request);
  for i := 0 to Length(g) - 1 do LEConvertUInt8To(g[i], 23 + (i * 1), request);
  for i := 0 to Length(b) - 1 do LEConvertUInt8To(b[i], 35 + (i * 1), request);
  for i := 0 to Length(w) - 1 do LEConvertUInt8To(w[i], 47 + (i * 1), request);
  SendRequest(request);
end;

procedure TBrickletLEDStrip.GetRGBWValues(const index: word; const length2: byte; out r: TArray0To11OfUInt8; out g: TArray0To11OfUInt8; out b: TArray0To11OfUInt8; out w: TArray0To11OfUInt8);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_RGBW_VALUES, 11);
  LEConvertUInt16To(index, 8, request);
  LEConvertUInt8To(length2, 10, request);
  response := SendRequest(request);
  for i := 0 to 11 do r[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 11 do g[i] := LEConvertUInt8From(20 + (i * 1), response);
  for i := 0 to 11 do b[i] := LEConvertUInt8From(32 + (i * 1), response);
  for i := 0 to 11 do w[i] := LEConvertUInt8From(44 + (i * 1), response);
end;

procedure TBrickletLEDStrip.SetChannelMapping(const mapping: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_SET_CHANNEL_MAPPING, 9);
  LEConvertUInt8To(mapping, 8, request);
  SendRequest(request);
end;

function TBrickletLEDStrip.GetChannelMapping: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_CHANNEL_MAPPING, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletLEDStrip.EnableFrameRenderedCallback;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_ENABLE_FRAME_RENDERED_CALLBACK, 8);
  SendRequest(request);
end;

procedure TBrickletLEDStrip.DisableFrameRenderedCallback;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_DISABLE_FRAME_RENDERED_CALLBACK, 8);
  SendRequest(request);
end;

function TBrickletLEDStrip.IsFrameRenderedCallbackEnabled: boolean;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_IS_FRAME_RENDERED_CALLBACK_ENABLED, 8);
  response := SendRequest(request);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletLEDStrip.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LED_STRIP_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletLEDStrip.CallbackWrapperFrameRendered(const packet: TByteArray);
var length2: word;
begin
  if (Assigned(frameRenderedCallback)) then begin
    length2 := LEConvertUInt16From(8, packet);
    frameRenderedCallback(self, length2);
  end;
end;

end.
